; ##############################################################################
; ##############################################################################
; ##############################################################################
; x33 senden und 8 BYTES empfangen und im SRAM ablegen							
DS_READ_ROM:
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE
	; MASTER TX x33 (read ROM)					
	ldi	temp1,0x33			
	rcall ONE_WIRE_DATA_WRITE
	; MASTER RX 8 BYTE und im SRAM ablegen		
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_ROM_BEREICH+0),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_ROM_BEREICH+1),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_ROM_BEREICH+2),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_ROM_BEREICH+3),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_ROM_BEREICH+4),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_ROM_BEREICH+5),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_ROM_BEREICH+6),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_ROM_BEREICH+7),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; xBE senden und 9 BYTES empfangen und im SRAM ablegen							
DS_RED_SCRATCHPAD:
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE
	; MASTER TX xCC (SKIP ROM)					
	ldi	temp1,0xCC
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX xBE (read SCRATCHPAD)					
	ldi	temp1,0xBE			
	rcall ONE_WIRE_DATA_WRITE
	; MASTER RX 9 BYTE und im SRAM ablegen		
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_SCRATCHPAD_BEREICH+0),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_SCRATCHPAD_BEREICH+1),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_SCRATCHPAD_BEREICH+2),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_SCRATCHPAD_BEREICH+3),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_SCRATCHPAD_BEREICH+4),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_SCRATCHPAD_BEREICH+5),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_SCRATCHPAD_BEREICH+6),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_SCRATCHPAD_BEREICH+7),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_SCRATCHPAD_BEREICH+8),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DS_MESSEN:
	;Reset und Presence-Test					
	rcall ONE_WIRE_RESET_PRESENCE
	; MASTER TX xCC (skip ROM)					
	ldi	temp1,0xCC			
	rcall ONE_WIRE_DATA_WRITE	
	; MASTER TX x44 (convert T)					
	ldi	temp1,0x44
	rcall ONE_WIRE_DATA_WRITE	
	; voll POWER (strong pullup )				
	sbi PORTC,0		; HIGH-PEGEL			
	sbi DDRC,0		; AUF AUSGANG			
	; Pause 									
	rcall wait_1s
	; PIN auf Eingan							
	sbi PORTC,0		; HIGH-PEGEL			
	cbi DDRC,0		; AUF EINGANG			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
